package lcsb.mapviewer.api.chemical;

import java.awt.geom.Point2D;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lcsb.mapviewer.api.BaseController;
import lcsb.mapviewer.api.QueryException;
import lcsb.mapviewer.services.SecurityException;

@RestController
@RequestMapping("/chemical")
public class ChemicalController extends BaseController {

	@Autowired
	private ChemicalRestImpl chemicalController;

	@RequestMapping(value = "/getChemicalsByQuery", method = { RequestMethod.GET, RequestMethod.POST }, produces = { MediaType.APPLICATION_JSON_VALUE })
	public List<Map<String, Object>> getChemicalsByQuery(@RequestParam(value = "token") String token, @RequestParam(value = "projectId") String projectId,
			@RequestParam(value = "columns", defaultValue = "") String columns, @RequestParam(value = "query") String query)
			throws SecurityException, QueryException {
		return chemicalController.getChemicalsByQuery(token, projectId, columns, query);
	}

	@RequestMapping(value = "/getChemicalsByTarget", method = { RequestMethod.GET, RequestMethod.POST }, produces = { MediaType.APPLICATION_JSON_VALUE })
	public List<Map<String, Object>> getChemicalsByTarget(@RequestParam(value = "token") String token, @RequestParam(value = "projectId") String projectId,
			@RequestParam(value = "targetType", defaultValue = "ALIAS") String targetType, @RequestParam(value = "targetId", defaultValue = "") String targetId,
			@RequestParam(value = "columns", defaultValue = "") String columns) throws SecurityException, QueryException {
		return chemicalController.getChemicalsByTarget(token, projectId, targetType, targetId, columns);
	}

}