package lcsb.mapviewer.api.genomics;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lcsb.mapviewer.api.BaseController;
import lcsb.mapviewer.api.QueryException;
import lcsb.mapviewer.services.SecurityException;
import lcsb.mapviewer.services.view.ReferenceGenomeView;

@RestController
@RequestMapping("/genomics")
public class ReferenceGenomeController extends BaseController {

	@Autowired
	private ReferenceGenomeRestImpl referenceGenomeController;

	@RequestMapping(value = "/getReferenceGenome", method = { RequestMethod.GET, RequestMethod.POST }, produces = { MediaType.APPLICATION_JSON_VALUE })
	public ReferenceGenomeView getDrugsByQuery(@RequestParam(value = "token") String token, @RequestParam(value = "organism") String organism,
			@RequestParam(value = "type") String type, @RequestParam(value = "version", defaultValue = "") String version) throws SecurityException, QueryException {
		return referenceGenomeController.getReferenceGenome(token, organism, type, version);
	}
}